#!/usr/bin/env node

const resolveCwd = require('resolve-cwd');
const path = require('path');
const shelljs = require('shelljs');
const moment =require('moment');
const yParser = require('yargs-parser');
const pkg = require('../package.json');
const chalk = require('chalk');
const debug = require('debug')('bin:client');
const yosay = require('../lib/util/hellosay');

// set process environment
const config = {
  'dir':  path.dirname(require.resolve('../package')),
  'version': pkg.version,
  'script': process.argv[2],
  'npmRoot': path.resolve(__dirname, '../'),
  'npmClient': 'tnpm',
  'argv': yParser(process.argv.slice(3)),
  'clientName': 'dingtalk-pro',
  'brandName': 'dingtalk',
  'npmName': '@ali/dingtalk-pro',
  'WHITE_LIST': ['@ali', '@alipay'],
  'PLUGIN_REGEXP': '^(@ali\\/)?dingtalk-plugin-'
}

process.env.config = JSON.stringify(config);
debug(`npmRoot: ${__dirname}`);

const localCLI = resolveCwd.silent(`${config.npmName}/bin/client`);
if (localCLI && localCLI !== __filename) {
  debug(`Using local install of ${config.clientName} cli`);
  require(localCLI);
} else {
  console.log(yosay(`Hello, Welcome to \n${config.clientName}\n\n ${moment().format('YYYY-MM-DD hh:mm')}`))
  require('../lib/cli');
}
