const shelljs = require('shelljs');
const util = require('../util');
const chalk = require('chalk');
const config = JSON.parse(process.env.config);
const WHITE_LIST = config.WHITE_LIST;
const brandName = config.brandName;
const npmClient = config.npmClient;

module.exports = function(client) {
  client
  .registryCommand('dev <cmd>')
  .description(chalk.bold.blue('system cmd: link or unlink plugin to root node_module directory'))
  .action(function (cmd) {
    const pluginName = client.rootGeneratorName();
    if (cmd !== 'unlink' || cmd !== 'link') {
      return;
    }

    if (util.isPluginName(pluginName)) {
      if (client.pluginIsExist(pluginName)) {
        console.log('plugin is exist')
      } else {
        shelljs.exec(`${npmClient} link`, function(code, stdout, stderr) {
          if (code === 0) {
            console.log('link successful')
          }
        })
      }
      
    } else {
      // @ali/client-plugin-xx or client-plugin-xx
      this.log.error(`plugin name ${plugin} is illegal, example: ${brandName}-plugin-xx, ${WHITE_LIST.map(prefix => prefix + '/' + brandName + '-plugin-xx').join(',')}`)
    }
  });
} 