/**
 * ----------------------------------
 * @file add.js
 * @desc 拉取特定的插件
 * @author Matrix <fangbo.fb@alibaba-inc.com>
 * @create: 2018/6
 * ----------------------------------
 */
const shelljs = require('shelljs');
const util = require('../util');
const chalk = require('chalk');

module.exports = function(client) {
  client
  .registryCommand('install [plugin]')
  .alias('i')
  .description(chalk.bold.blue('system cmd: install plugin with global director'))
  .action(function (plugin) {
    if (util.isPluginName(plugin)) {
      const child = shelljs.exec(`tnpm i ${plugin} -g`, function(code, stdout, stderr) {
        if (code === 0) {
          console.log(`${plugin} installed finish`)
        } else {
          console.log(stderr)
        }
      })
    } else {
      console.log(`plugin name ${plugin} is illegal, example: @ali/client-plugin-xx or client-plugin-xx`)
    }
  });
} 